import { CodeBuildProjectType, IamRoleType, LambdaFunctionType, S3BucketType } from './resource-types';
import * as s3 from 'aws-cdk-lib/aws-s3';
import * as codebuild from 'aws-cdk-lib/aws-codebuild';
import * as lambdaNodeJs from 'aws-cdk-lib/aws-lambda-nodejs';
import { aws_iam } from 'aws-cdk-lib';
export declare enum AppName {
    DEFAULT = 0
}
export interface IApp {
    setS3Bucket(type: S3BucketType, s3Bucket: s3.Bucket): void;
    getS3Bucket(type: S3BucketType): s3.Bucket;
    setCodeBuildProject(type: CodeBuildProjectType, project: codebuild.PipelineProject): void;
    getCodeBuildProject(type: CodeBuildProjectType): codebuild.PipelineProject;
    setLambdaFunction(type: LambdaFunctionType, fn: lambdaNodeJs.NodejsFunction): void;
    getLambdaFunction(type: LambdaFunctionType): lambdaNodeJs.NodejsFunction;
    setIamRole(type: IamRoleType, role: aws_iam.Role): void;
    getIamRole(type: IamRoleType): aws_iam.Role;
}
export declare class AppModel implements IApp {
    private _s3Buckets;
    private _codeBuildProjects;
    private _lambdaFunctions;
    private _iamRoles;
    constructor();
    setS3Bucket(type: S3BucketType, s3Bucket: s3.Bucket): void;
    getS3Bucket(type: S3BucketType): s3.Bucket;
    setCodeBuildProject(type: CodeBuildProjectType, project: codebuild.PipelineProject): void;
    getCodeBuildProject(type: CodeBuildProjectType): codebuild.PipelineProject;
    setLambdaFunction(type: LambdaFunctionType, project: lambdaNodeJs.NodejsFunction): void;
    getLambdaFunction(type: LambdaFunctionType): lambdaNodeJs.NodejsFunction;
    setIamRole(type: IamRoleType, role: aws_iam.Role): void;
    getIamRole(type: IamRoleType): aws_iam.Role;
}
